# coding: utf-8

"""
    DNL API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.3.52
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cli_dnl
from cli_dnl.rest import ApiException
from cli_dnl.apis.product_api import ProductApi
from . settings import *

def product_rand_data(**kwargs):
    aid, a, al = rand_agent()
    random.shuffle(al)
    agents = [a.agent_id for a in al[0:5]]
    #agents.append(24)
    cl = rand_client()[2]
    random.shuffle(cl)
    clients = [c.client_id for c in cl[0:5]]
    allowed_clients = [c.client_id for c in cl[0:5]]

    data = {
        'agents': agents,
        'description': bla_bla(10),
        'name': 'product_' + bla(6),
        'rate_table_id': rand_rate_table()[0],
        'allowed_clients': allowed_clients,
        'clients': clients,
        'route_plan_id': rand_route_plan()[0],
        'agent_id': aid,
        'type': random.choice(['public', 'private']),
        'tech_prefix': dig(6)
    }
    for k in kwargs:
        data[k]=kwargs[k]
    return data

class TestProductApi(unittest.TestCase):
    """ ProductApi unit test stubs """

    def setUp(self):
        self.api = cli_dnl.apis.product_api.ProductApi()
        auth()

    def tearDown(self):
        pass

    def test_product_analysis_create_post(self):
        """
        Test case for product_analysis_create_post


        """
        pass

    def test_product_analysis_list_get(self):
        """
        Test case for product_analysis_list_get


        """
        pass

    def test_product_analysis_uuid_delete(self):
        """
        Test case for product_analysis_uuid_delete


        """
        pass

    def test_product_analysis_uuid_get(self):
        """
        Test case for product_analysis_uuid_get


        """
        pass

    def test_product_analysis_uuid_items_get(self):
        """
        Test case for product_analysis_uuid_items_get


        """
        pass

    def test_product_analysis_uuid_patch(self):
        """
        Test case for product_analysis_uuid_patch


        """
        pass

    def test_product_create_post(self):
        """
        Test case for product_create_post

        
        """
        ret=self.api.product_create_post(body=product_rand_data())
        assert(ret.success)
        new=self.api.product_id_get(id=ret.object_id)
        try:
            ret = self.api.product_create_post(body=product_rand_data(name=new.name))
            assert (not ret.success)
        except:
            pass
        pass

    def test_product_id_delete(self):
        """
        Test case for product_id_delete

        
        """
        pid=rand_product()[0]
        ret=self.api.product_id_delete(id=pid)
        assert(ret.success)
        pass

    def test_product_id_get(self):
        """
        Test case for product_id_get

        
        """
        pid = rand_product()[0]
        ret=self.api.product_id_get(id=pid)
        assert (ret.success)
        pass

    def test_product_id_patch(self):
        """
        Test case for product_id_patch

        
        """
        pid = rand_product()[0]
        data={'route_plan_id': rand_route_plan()[0]}
        ret = self.api.product_id_patch(id=pid, body=data)
        print(pid,json.dumps(data),ret)
        assert (ret.success)
        return
        pid = rand_product()[0]
        ret = self.api.product_id_patch(id=pid,body=product_rand_data())
        assert (ret.success)
        print(ret.payload.update_at)
        assert(datetime.now(UTC)-ret.payload.update_at < timedelta(seconds=5))
        pass1

    def test_product_id_send_patch(self):
        """
        Test case for product_id_send_patch


        """
        pass

    def test_product_list_get(self):
        """
        Test case for product_list_get

        
        """
        id,pr,prd=rand_product(per_page=30)
        o=['name', 'route_plan_id', 'rate_table_id', 'type', 'agent_id', 'update_by', 'update_at',
           'route_plan_name', 'rate_table_name', 'tech_prefix'
           ]
        for order in o:
            for dir in ['asc','desc']:
                pp=random.randint(1,10)
                ret=self.api.product_list_get(order_by=order,order_dir=dir,per_page=pp,
                            update_at_gt=get_rand('date'))
                assert(ret.success)
                print(order,'success')
                """
                ret = self.api.product_list_get(order_by=order, order_dir=dir, per_page=pp,
                            name=pr.name)
                assert (ret.success and len(ret.payload.items)==1)
                ret = self.api.product_list_get(order_by=order, order_dir=dir, per_page=pp,
                            route_plan_id=pr.route_plan_id)
                assert (ret.success and len(ret.payload.items) > 0 )
                ret = self.api.product_list_get(order_by=order, order_dir=dir, per_page=pp,
                            rate_table_id=pr.rate_table_id)
                assert (ret.success and len(ret.payload.items) > 0)
                ret = self.api.product_list_get(order_by=order, order_dir=dir, per_page=pp,
                            type=pr.type)
                assert (ret.success and len(ret.payload.items) > 0)
                """


        pass

    def test_product_public_get(self):
        """
        Test case for product_public_get

        
        """

        pid = rand_product()[0]
        logoff()
        ret = self.api.product_public_get()
        assert (ret.success)

        pass


if __name__ == '__main__':
    unittest.main()
